import { renderless, api } from '@opentinyvue/vue-renderless/slider/vue';
import { defineComponent, props, setup } from '@opentinyvue/vue-common';

function normalizeComponent(scriptExports, render, staticRenderFns, functionalTemplate, injectStyles, scopeId, moduleIdentifier, shadowMode) {
  var options = typeof scriptExports === "function" ? scriptExports.options : scriptExports;
  if (render) {
    options.render = render;
    options.staticRenderFns = staticRenderFns;
    options._compiled = true;
  }
  var hook;
  if (injectStyles) {
    hook = injectStyles;
  }
  if (hook) {
    if (options.functional) {
      options._injectStyles = hook;
      var originalRender = options.render;
      options.render = function renderWithStyleInjection(h, context) {
        hook.call(context);
        return originalRender(h, context);
      };
    } else {
      var existing = options.beforeCreate;
      options.beforeCreate = existing ? [].concat(existing, hook) : [hook];
    }
  }
  return {
    exports: scriptExports,
    options
  };
}

var __vue2_script = defineComponent({
  emits: ["update:modelValue", "change", "start", "stop"],
  props: [].concat(props, ["modelValue", "disabled", "max", "min", "step", "numPages", "showTip", "showInput", "height", "range", "formatTooltip", "showSteps", "showLabel", "formatLabel", "vertical", "unit", "changeCompat"]),
  setup: function setup$1(props2, context) {
    return setup({
      props: props2,
      context,
      renderless,
      api
    });
  }
});
var render = function render2() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("div", {
    staticClass: "relative flex h-auto flex-row w-full",
    attrs: {
      "data-tag": "tiny-slider"
    }
  }, [_c("div", {
    staticClass: "self-center mr-2 block sm:hidden text-sm",
    attrs: {
      "data-tag": "tiny-slider-left"
    }
  }, [_vm._t("left", function() {
    return [_vm._v(" " + _vm._s(_vm.min) + " ")];
  })], 2), _c("div", {
    ref: "slider",
    staticClass: "relative w-full h-1 flex-1 my-4 mx-0 bg-color-none-disabled",
    class: [_vm.state.disabled ? "cursor-default" : "cursor-pointe"],
    attrs: {
      "role": "tiny-slider"
    },
    on: {
      "touchstart": _vm.bindMouseDown,
      "mousedown": _vm.bindMouseDown
    }
  }, [_c("div", {
    staticClass: "absolute rounded left-0 h-1",
    class: [_vm.state.disabled ? "bg-color-none" : "bg-color-brand"],
    style: _vm.state.barStyle,
    attrs: {
      "data-tag": "tiny-slider-range",
      "role": "tiny-slider__range"
    }
  }), _vm.state.leftBtnShow ? _c("div", {
    staticClass: "absolute w-6 h-6 sm:w-5 sm:h-5 box-border shadow-xsm rounded-full bg-color-bg-1 -translate-x-2.5 -translate-y-1/2 left-0 top-0.5",
    class: [_vm.state.disabled ? "border-color-none-hover cursor-not-allowed" : "cursor-grab hover:border-color-brand-hover hover:border-solid hover:border-2 active:border-2 active:border-solid active:border-color-brand-active", _vm.state.activeIndex === 0 ? "z-20" : "z-10"],
    style: _vm.state.leftBtnStyle,
    attrs: {
      "data-tag": "tiny-slider-handle",
      "role": "tiny-slider__handle",
      "tabindex": "0"
    },
    on: {
      "mouseenter": _vm.displayTip,
      "mouseleave": _vm.hideTip,
      "touchstart": _vm.displayTip,
      "touchend": _vm.hideTip,
      "keydown": _vm.bindKeyDown
    }
  }) : _vm._e(), _vm.state.rightBtnShow ? _c("div", {
    staticClass: "absolute w-6 h-6 sm:w-5 sm:h-5 box-border shadow-xsm rounded-full bg-color-bg-1 -translate-x-2.5 -translate-y-1/2 left-0 top-0.5",
    class: [_vm.state.disabled ? "border-color-none-hover cursor-not-allowed" : "cursor-grab hover:border-color-brand-hover hover:border-solid hover:border-2 active:border-2 active:border-solid active:border-color-brand-active", _vm.state.activeIndex === 1 ? "z-20" : "z-10"],
    style: _vm.state.rightBtnStyle,
    attrs: {
      "data-tag": "tiny-slider-handle",
      "role": "tiny-slider__handle",
      "tabindex": "0"
    },
    on: {
      "mouseenter": _vm.displayTip,
      "mouseleave": _vm.hideTip,
      "touchstart": _vm.displayTip,
      "touchend": _vm.hideTip,
      "keydown": _vm.bindKeyDown
    }
  }) : _vm._e(), _c("div", {
    directives: [{
      name: "show",
      rawName: "v-show",
      value: _vm.showTip && _vm.state.showTip,
      expression: "showTip && state.showTip"
    }],
    ref: "sliderTip",
    class: ["absolute bottom-6 px-4 py-1.5 bg-color-bg-1 shadow-lg rounded select-none z-10 whitespace-nowrap text-sm sm:text-xs", "after:content-[''] after:absolute after:left-1/2 after:-bottom-2 after:-translate-x-1/2 after:w-0 after:h-2", "after:border-t-8 after:border-r-8 after:border-l-8 after:border-t-color-bg-1 after:border-x-transparent"],
    style: _vm.state.tipStyle,
    attrs: {
      "data-tag": "tiny-slider-showtips"
    }
  }, [_vm._v(" " + _vm._s(_vm.state.tipValue) + " ")]), _vm.showSteps ? _c("div", {
    attrs: {
      "data-tag": "tiny-slider-showsteps"
    }
  }, _vm._l(_vm.state.points, function(p, i) {
    return _c("div", {
      key: p.position + i,
      staticClass: "w-0.5 h-0.5 rounded-full sm:rounded absolute sm:h-1 bottom-1.5 sm:bottom-1",
      class: [p.value >= Math.min(_vm.state.rightBtnValue, _vm.state.leftBtnValue) && p.value <= Math.max(_vm.state.rightBtnValue, _vm.state.leftBtnValue) ? "bg-color-brand" : "bg-color-bg-3", _vm.state.disabled ? "bg-color-border-disabled" : ""],
      style: {
        "left": p.position
      },
      attrs: {
        "data-tag": "tiny-slider-points"
      }
    });
  }), 0) : _vm._e(), _vm.showLabel ? _c("div", {
    staticClass: "hidden sm:block w-full h-4 mt-4",
    attrs: {
      "data-tag": "tiny-slider-label"
    }
  }, _vm._l(_vm.state.labels, function(p, i) {
    return _c("div", {
      key: p.position + i,
      staticClass: "absolute -translate-x-1/2 first:translate-x-0 last:-translate-x-full",
      class: [_vm.state.disabled ? "text-color-text-disabled" : "text-color-text-primary"],
      style: {
        "left": p.position,
        "max-width": "calc( " + _vm.max / _vm.step + "% - 20px )"
      }
    }, [_vm._v(" " + _vm._s(p.label) + " ")]);
  }), 0) : _vm._e()]), _c("div", {
    staticClass: "self-center ml-2 block text-sm sm:hidden",
    attrs: {
      "data-tag": "tiny-slider-right"
    }
  }, [_vm._t("right", function() {
    return [_vm._v(" " + _vm._s(_vm.max) + " ")];
  })], 2), _vm.showInput ? [_vm.state.isDouble ? _c("div", {
    staticClass: "relative flex justify-between items-center ml-5",
    attrs: {
      "data-tag": "tiny-slider-isdouble"
    }
  }, [_vm._t("default", function() {
    return [_c("input", {
      directives: [{
        name: "model",
        rawName: "v-model",
        value: _vm.state.inputValue[0],
        expression: "state.inputValue[0]"
      }],
      staticClass: "h-8 w-12 outline-0 px-2 py-0 text-center border border-color-bg-3 hover:border-color-border-hover focus:border-color-brand-focus disabled:border-color-border rounded",
      attrs: {
        "type": "text",
        "disabled": _vm.state.disabled
      },
      domProps: {
        "value": _vm.state.inputValue[0]
      },
      on: {
        "change": function change($event) {
          return _vm.inputValueChange($event, "left");
        },
        "input": function input($event) {
          if ($event.target.composing) return;
          _vm.$set(_vm.state.inputValue, 0, $event.target.value);
        }
      }
    }), _c("div", {
      staticClass: "h-px w-4 mx-2 my-0",
      class: [_vm.state.disabled ? "bg-color-border-disabled" : "bg-color-text-primary"]
    }), _c("input", {
      directives: [{
        name: "model",
        rawName: "v-model",
        value: _vm.state.inputValue[1],
        expression: "state.inputValue[1]"
      }],
      staticClass: "h-8 w-12 outline-0 px-2 py-0 text-center border border-color-bg-3 hover:border-color-border-hover focus:border-color-brand-focus disabled:border-color-border rounded",
      attrs: {
        "type": "text",
        "disabled": _vm.state.disabled
      },
      domProps: {
        "value": _vm.state.inputValue[1]
      },
      on: {
        "change": function change($event) {
          return _vm.inputValueChange($event, "right");
        },
        "input": function input($event) {
          if ($event.target.composing) return;
          _vm.$set(_vm.state.inputValue, 1, $event.target.value);
        }
      }
    }), _c("span", {
      staticClass: "ml-2"
    }, [_vm._v(_vm._s(_vm.unit))])];
  }, {
    "slotScope": _vm.state.inputValue
  })], 2) : _c("div", {
    staticClass: "ml-5 self-center",
    attrs: {
      "data-tag": "tiny-slider-active-value"
    }
  }, [_vm._t("default", function() {
    return [_c("input", {
      directives: [{
        name: "model",
        rawName: "v-model",
        value: _vm.state.activeValue,
        expression: "state.activeValue"
      }],
      staticClass: "h-8 w-12 outline-0 px-2 py-0 text-center border border-color-bg-3 hover:border-color-border-hover focus:border-color-brand-focus disabled:border-color-border rounded",
      attrs: {
        "type": "text",
        "disabled": _vm.state.disabled
      },
      domProps: {
        "value": _vm.state.activeValue
      },
      on: {
        "change": _vm.inputOnChange,
        "input": function input($event) {
          if ($event.target.composing) return;
          _vm.$set(_vm.state, "activeValue", $event.target.value);
        }
      }
    }), _c("span", {
      staticClass: "ml-2"
    }, [_vm._v(_vm._s(_vm.unit))])];
  }, {
    "slotScope": _vm.state.activeValue
  })], 2)] : _vm._e()], 2);
};
var staticRenderFns = [];
var __cssModules = {};
var __component__ = /* @__PURE__ */ normalizeComponent(__vue2_script, render, staticRenderFns, false, __vue2_injectStyles);
function __vue2_injectStyles(context) {
  for (var o in __cssModules) {
    this[o] = __cssModules[o];
  }
}
var mobileFirst = /* @__PURE__ */ function() {
  return __component__.exports;
}();

export { mobileFirst as default };
